Index: trunk/org.txm.texts.rcp/src/org/txm/texts/rcp/TextsViewEditor.java
===================================================================
--- trunk/org.txm.texts.rcp/src/org/txm/texts/rcp/TextsViewEditor.java	(revision 3440)
+++ trunk/org.txm.texts.rcp/src/org/txm/texts/rcp/TextsViewEditor.java	(revision 3441)
@@ -18,6 +18,7 @@
 import org.eclipse.swt.graphics.Image;
 import org.eclipse.swt.layout.GridData;
 import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Label;
 import org.eclipse.swt.widgets.TableColumn;
 import org.txm.core.results.Parameter;
 import org.txm.edition.rcp.handlers.OpenEdition;
@@ -36,6 +37,9 @@
 	@Parameter(key = "columns")
 	PropertiesSelector<StructuralUnitProperty> propertiesSelector;
 	
+	@Parameter(key = "negativeFilters")
+	org.eclipse.swt.widgets.Text negativeFiltersText;
+	
 	TableViewer viewer;
 //	HashMap<String, TableViewerColumn> columns = new HashMap<String, TableViewerColumn>();
 	
@@ -44,6 +48,8 @@
 		
 		this.getParent().setLayout(new GridLayout(1, true));
 		
+		this.getMainParametersComposite().getLayout().numColumns = 10;
+		
 		propertiesSelector = new PropertiesSelector<>(this.getMainParametersComposite());
 		ArrayList<StructuralUnitProperty> properties = new ArrayList<>(getResult().getCorpus().getStructuralUnitProperties("text"));
 		for (int i = 0 ; i < properties.size() ; i++) {
@@ -56,6 +62,14 @@
 		ComputeSelectionListener computeSelectionListener = new ComputeSelectionListener(this);
 		propertiesSelector.addSelectionListener(computeSelectionListener);
 		
+		new Label(this.getMainParametersComposite(), SWT.NONE).setText("Negative filters (p1=v1;p2=v2)");
+		
+		negativeFiltersText = new org.eclipse.swt.widgets.Text(this.getMainParametersComposite(), SWT.BORDER);
+		negativeFiltersText.addSelectionListener(computeSelectionListener);
+		GridData gdata = new GridData(GridData.FILL, GridData.CENTER, true, false);
+		gdata.minimumWidth = 300;
+		negativeFiltersText.setLayoutData(gdata);
+		
 		viewer = new TableViewer(this.getResultArea(), SWT.NONE);
 		viewer.getTable().setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
 		viewer.getTable().setHeaderVisible(true);
@@ -159,7 +173,13 @@
 			
 		}
 		//
-		viewer.setInput(getResult().getCorpus().getProject().getTexts());
+		ArrayList<Text> texts = new ArrayList<>();
+		for (Text text : getResult().getCorpus().getProject().getTexts()) {
+			if (this.getResult().getLines().containsKey(text.getName())) {
+				texts.add(text);
+			}
+		}
+		viewer.setInput(texts);
 		
 		viewer.addDoubleClickListener(new IDoubleClickListener() {
 			
Index: trunk/org.txm.texts.core/src/org/txm/texts/core/TextsView.java
===================================================================
--- trunk/org.txm.texts.core/src/org/txm/texts/core/TextsView.java	(revision 3440)
+++ trunk/org.txm.texts.core/src/org/txm/texts/core/TextsView.java	(revision 3441)
@@ -3,6 +3,7 @@
 import java.io.File;
 import java.io.PrintWriter;
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.LinkedHashMap;
 import java.util.List;
 
@@ -23,12 +24,18 @@
 	@Parameter(key = "columns")
 	ArrayList<StructuralUnitProperty> pColumns;
 	
+//	@Parameter(key = "positiveFilters")
+//	ArrayList<String> positiveFilters;
+	
+	@Parameter(key = "negativeFilters")
+	String negativeFilters;
+	
 	private LinkedHashMap<String, ArrayList<String>> result;
 	
 	public MainCorpus getCorpus() {
 		return (MainCorpus)parent;
 	}
-
+	
 	public TextsView(MainCorpus corpus) {
 		
 		super(corpus);
@@ -40,14 +47,16 @@
 	}
 	
 	
-
+	
 	@Override
 	public boolean saveParameters() throws Exception {
 		
 		this.saveParameter("columns", StringUtils.join(pColumns, "\t"));
+//		this.saveParameter("positiveFilters", StringUtils.join(positiveFilters, "\t"));
+		this.saveParameter("negativeFilters", negativeFilters);
 		return true;
 	}
-
+	
 	@Override
 	public boolean loadParameters() throws Exception {
 		
@@ -65,14 +74,26 @@
 			this.pColumns = new ArrayList(Property.stringToProperties(getCorpus(), v));
 		}
 		
+		v = this.getStringParameterValue("negativeFilters").toString();
+		if (v.contains("=")) {
+			this.negativeFilters = v;
+		} else {
+			this.negativeFilters = "";
+		}
+		
+//		v = this.getStringParameterValue("positiveFilters").toString();
+//		if (v.contains("=")) {
+//			this.positiveFilters = new ArrayList<>(Arrays.asList(v.split("\t")));
+//		} else {
+//			this.positiveFilters = new ArrayList<>();
+//		}
+		
 		return pColumns != null;
 	}
-
+	
 	@Override
 	public boolean setParameters(TXMParameters parameters) throws Exception {
 		
-		
-		
 		if (parameters.get("columns") != null) {
 			
 			Object o = parameters.get("columns");
@@ -90,36 +111,36 @@
 		}
 		return false;
 	}
-
+	
 	@Override
 	public String getName() {
 		
 		return "Texts ("+pColumns.toString()+")";
 	}
-
+	
 	@Override
 	public String getSimpleName() {
 		
 		return "Texts";
 	}
-
+	
 	@Override
 	public String getDetails() {
 		
 		return getName();
 	}
-
+	
 	@Override
 	public void clean() {
 		
 	}
-
+	
 	@Override
 	public boolean canCompute() throws Exception {
-
+		
 		return pColumns != null;
 	}
-
+	
 	@Override
 	protected boolean _compute(TXMProgressMonitor monitor) throws Exception {
 		
@@ -128,6 +149,7 @@
 		// preset arrays
 		String[] texts = getCorpus().getCorpusTextIdsList();
 		for (String t : texts) {
+			
 			ArrayList<String> values = new ArrayList<String>();
 			result.put(t, values);
 			
@@ -152,9 +174,32 @@
 			}
 		}
 		
+		if (negativeFilters.length() > 0 && pColumns.size() > 0) {
+			
+			ArrayList<String> columnNames = new ArrayList<>(pColumns.size());
+			for (StructuralUnitProperty p : pColumns) columnNames.add(p.getName());
+			
+			String[] filters = negativeFilters.split(";");
+			
+			ArrayList<String> keys = new ArrayList<>(result.keySet());
+			for (String text : keys) {
+				
+				for (String negativeFilter : filters) {
+					String[] split = negativeFilter.split("=", 2);
+					if (split.length == 2 
+							&& columnNames.contains(split[0]) 
+							&& result.get(text).get(columnNames.indexOf(split[0])).matches(split[1])) {
+						// remove this line
+						result.remove(text);
+						break;
+					}
+				}
+			}
+		}
+		
 		return true;
 	}
-
+	
 	@Override
 	protected boolean _toTxt(File outfile, String encoding, String colseparator, String txtseparator) throws Exception {
 		
@@ -168,7 +213,7 @@
 		writer.close();
 		return false;
 	}
-
+	
 	@Override
 	public String getResultType() {
 		return "TextView";
@@ -177,7 +222,7 @@
 	public LinkedHashMap<String, ArrayList<String>> getLines() {
 		return result;
 	}
-
+	
 	public List<StructuralUnitProperty> getColumns() {
 		
 		return pColumns;
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/scripts/ExecuteImportScript.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/scripts/ExecuteImportScript.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/scripts/ExecuteImportScript.java	(revision 3441)
@@ -86,20 +86,34 @@
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 		String filename = null, filepath = null;
-		if (event.getParameters().containsKey("org.txm.rcp.commands.commandParameter3")) {
-			filename = event.getParameter("org.txm.rcp.commands.commandParameter3"); //$NON-NLS-1$
+		File script = null;
+		Boolean updateMode = false;
+		if (event.getParameters().containsKey("org.txm.rcp.commands.importscript")) {
+			filename = event.getParameter("org.txm.rcp.commands.importscript"); //$NON-NLS-1$
 			filepath = "scripts/groovy/user/org/txm/scripts/importer/" + filename; //$NON-NLS-1$
 		}
+		else if (event.getParameters().containsKey("org.txm.rcp.commands.usecorporaselection")) {
+			boolean useCorporaSelection = "true".equals(event.getParameter("org.txm.rcp.commands.usecorporaselection")); //$NON-NLS-1$
+			//filepath = "scripts/groovy/user/org/txm/scripts/importer/" + filename; //$NON-NLS-1$
+		} 
 		else {
 			Shell shell = HandlerUtil.getActiveWorkbenchWindowChecked(event).getShell();
 			FileDialog dialog = new FileDialog(shell, SWT.SAVE);
 			dialog.setFilterPath(Toolbox.getTxmHomePath() + "/scripts/groovy/user/org/txm/scripts/importer");
 			filepath = dialog.open();
+			
+			if (filepath == null) {
+				Log.warning("No Groovy entry point script selected. Aborted.);");
+				return null;
+			}
+			script = new File(filepath);
 		}
 		
-		if (filepath == null) return null;
+		if (event.getParameters().containsKey("org.txm.rcp.commands.importupdatemode")) {
+			updateMode = "true".equals(event.getParameter("org.txm.rcp.commands.importupdatemode"));
+		}
 		
-		OpenImportForm.openfile(filepath);
+		OpenImportForm.open(script, updateMode);
 		return null;
 	}
 	
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/ImportPreferencePage.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/ImportPreferencePage.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/ImportPreferencePage.java	(revision 3441)
@@ -57,6 +57,8 @@
 	/** The txtseparators. */
 	private ComboFieldEditor txtseparators;
 	
+	private BooleanFieldEditor askdefaultlang;
+	
 	private StringFieldEditor defaultlang;
 	
 	private StringFieldEditor empty_code;
@@ -135,9 +137,11 @@
 		rlayout.marginHeight = 5;
 		langGroup.setLayout(rlayout);
 		
-		defaultlang = new StringFieldEditor(TBXPreferences.IMPORT_DEFAULT_LANG, TXMUIMessages.defaultLanguage, langGroup);
+		defaultlang = new StringFieldEditor(TBXPreferences.CLIPBOARD_IMPORT_DEFAULT_LANG, TXMUIMessages.defaultLanguage, langGroup);
 		defaultlang.setEmptyStringAllowed(false);
 		
+		askdefaultlang = new BooleanFieldEditor(TBXPreferences.CLIPBOARD_IMPORT_ASK_LANG, "Ask lang when importing from clipboard", langGroup);
+		
 		Label l = new Label(langGroup, SWT.NONE);
 		l.setText(TXMUIMessages.noteColonUseValueToGuess);
 		GridData ldata = new GridData(SWT.FILL, SWT.FILL, true, false);
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java	(revision 3441)
@@ -38,6 +38,8 @@
 	 * To auto compute result and refresh editor when a form computing parameter is modified.
 	 */
 	public static final String AUTO_UPDATE_EDITOR = "auto_update_editor"; //$NON-NLS-1$
+	
+	public static final String AUTO_UPDATE_SUBRESULTS = "auto_update_subresults"; //$NON-NLS-1$
 	// public static final String AUTO_COMPUTE_ON_EDITOR_OPEN = "auto_compute_editor"; //$NON-NLS-1$
 	
 	public static final String SHOW_SEVERE_DIALOG = "show_severe_dialog";
@@ -88,6 +90,7 @@
 		preferences.put(UPDATE_LEVEL, "STABLE"); //$NON-NLS-1$
 		
 		preferences.putBoolean(AUTO_UPDATE_EDITOR, false);
+		preferences.putBoolean(AUTO_UPDATE_SUBRESULTS, false);
 		// preferences.putBoolean(AUTO_COMPUTE_ON_EDITOR_OPEN, true);
 		preferences.putBoolean(SHOW_SEVERE_DIALOG, false);
 		preferences.putBoolean(USER_ALERT_DELETE, false);
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/UserPreferencePage.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/UserPreferencePage.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/UserPreferencePage.java	(revision 3441)
@@ -58,6 +58,9 @@
 		this.addField(new BooleanFieldEditor(RCPPreferences.AUTO_UPDATE_EDITOR, TXMUIMessages.automaticRecomputingWhenChangingAParameter, BooleanFieldEditor.SEPARATE_LABEL, this
 				.getFieldEditorParent()));
 		
+		// Auto compute the result when a parameter changes
+		this.addField(new BooleanFieldEditor(RCPPreferences.AUTO_UPDATE_SUBRESULTS, "Automatically update sub-results", BooleanFieldEditor.SEPARATE_LABEL, this.getFieldEditorParent()));
+		
 		// this.addField(new BooleanFieldEditor(RCPPreferences.AUTO_COMPUTE_ON_EDITOR_OPEN, "Compute when opening its window", BooleanFieldEditor.SEPARATE_LABEL, this.getFieldEditorParent()));
 		
 		// Auto save each result after computing and auto load them at startup
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/ImportFormEditor.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/ImportFormEditor.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/ImportFormEditor.java	(revision 3441)
@@ -42,8 +42,11 @@
 import org.eclipse.ui.forms.widgets.FormToolkit;
 import org.eclipse.ui.forms.widgets.ScrolledForm;
 import org.txm.Toolbox;
+import org.txm.objects.CorpusBuild;
+import org.txm.objects.Project;
 import org.txm.rcp.editors.input.ImportFormEditorInput;
 import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.rcp.views.corpora.CorporaView;
 
 /**
  * display&edit the import parameters 
@@ -54,8 +57,8 @@
 	/** The Constant ID. */
 	public static final String ID = "org.txm.rcp.editors.imports.ImportFormEditor"; //$NON-NLS-1$
 
-	/** The groovyscript. */
-	private File groovyscript;
+	/** The import Name to run. */
+	private String importName;
 
 	/** The toolkit. */
 	private FormToolkit toolkit;
@@ -70,7 +73,11 @@
 	MetadataPage meta;
 
 	private ImportFormEditorInput finput;
+
+	private Boolean updateMode;
 	
+	protected Project project;
+	
 	/**
 	 * Instantiates a new import form editor.
 	 */
@@ -129,16 +136,47 @@
 		setInput(input);
 		finput = ((ImportFormEditorInput) input);
 		String txmhome = Toolbox.getTxmHomePath();
+		
 		File f = finput.getGroovyFile();
-		String filepath = f.getPath();
-		this.setGroovyscript(new File(txmhome, filepath));
+		if (f != null) {
+			String filepath = f.getPath();
+			String importName = ImportModuleCustomization.getName(new File(txmhome, filepath).getName());
+			this.setImportName(importName);
+		} else { // use the corpora view selection
+			
+			Object o = CorporaView.getFirstSelectedObject();
+			
+			if (o instanceof CorpusBuild) {
+				o = ((CorpusBuild)o).getProject();
+			}
+			
+			if (o instanceof Project) {
+				Project p = (Project)o;
+				this.setImportName(p.getImportModuleName());
+				this.project = p;
+			}
+		}
 		
+		this.setUpdateMode(finput.getUpdateMode());
+		
+		
+		
 		//ExecuteImportScript.getImportScriptFromToolboxPlugin(getGroovyscript()); // always update if script from Toolbox is more recent
 		
-		if (!getGroovyscript().exists()) // just a warning message
-			System.out.println(NLS.bind(TXMUIMessages.warningColonTheImportScriptIsMissingColonP0, getGroovyscript()));
+//		if (!getGroovyscript().exists()) // just a warning message
+//			System.out.println(NLS.bind(TXMUIMessages.warningColonTheImportScriptIsMissingColonP0, getGroovyscript()));
 	}
 
+	public void setUpdateMode(Boolean updateMode) {
+		
+		this.updateMode = updateMode;
+	}
+	
+	public Boolean getUpdateMode() {
+		
+		return this.updateMode;
+	}
+
 	/**
 	 * Checks if is dirty.
 	 *
@@ -191,10 +229,15 @@
 	 */
 	@Override
 	public String getPartName() {
-		if (main != null && main.getProject() != null) {
-			return TXMUIMessages.bind(TXMUIMessages.p0ImportWithP1,main.getProject().getName(),ImportModuleCustomization.getName(groovyscript.getName()));
+		
+		if (main != null && project != null) {
+			if (updateMode) {
+				return TXMUIMessages.bind("Update {0} ({1} import)", project.getName(), importName);
+			} else {
+				return TXMUIMessages.bind(TXMUIMessages.p0ImportWithP1, project.getName(), importName);
+			}
 		} else {
-			return TXMUIMessages.bind(TXMUIMessages.p0Import,ImportModuleCustomization.getName(groovyscript.getName()));
+			return TXMUIMessages.bind(TXMUIMessages.p0Import, importName);
 		}
 	}
 	
@@ -223,26 +266,11 @@
 		return meta;
 	}
 	
-	/**
-	 * Gets the groovy script.
-	 *
-	 * @return the groovy script
-	 */
-	public File getGroovyScript() {
-		return getGroovyscript();
+	public String getImportName() {
+		return importName;
 	}
-
-	/**
-	 * @return the groovyscript
-	 */
-	public File getGroovyscript() {
-		return groovyscript;
+	
+	public void setImportName(String importName) {
+		this.importName = importName;
 	}
-
-	/**
-	 * @param groovyscript the groovyscript to set
-	 */
-	public void setGroovyscript(File groovyscript) {
-		this.groovyscript = groovyscript;
-	}
 }
\ No newline at end of file
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/CommandsSection.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/CommandsSection.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/CommandsSection.java	(revision 3441)
@@ -122,7 +122,7 @@
 			}
 		}
 		else {
-			if ("txtLoader.groovy".equals(editor.getGroovyscript().getName())) {
+			if ("txt".equals(editor.getImportName())) {
 				referencePatternText.setText("text_id,l_n");
 				referencePatternProperties.setText("%s, %s");
 			} else {
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/EditionSection.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/EditionSection.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/EditionSection.java	(revision 3441)
@@ -57,9 +57,9 @@
 	 * @param stylesave
 	 * 
 	 * @param moduleParams
-	 * @param scriptName temporary parameter to detect if import module is xtzLoader.groovy
+	 * @param importName temporary parameter to detect if import module is xtzLoader.groovy
 	 */
-	public EditionSection(ImportFormEditor editor, FormToolkit toolkit2, ScrolledForm form2, Composite parent, int style, HashMap<String, Boolean> moduleParams, String scriptName) {
+	public EditionSection(ImportFormEditor editor, FormToolkit toolkit2, ScrolledForm form2, Composite parent, int style, HashMap<String, Boolean> moduleParams, String importName) {
 		super(editor, toolkit2, form2, parent, style, "edition");
 		
 		this.section.setText(TXMUIMessages.editions);
@@ -128,7 +128,7 @@
 			pageBreakText.setLayoutData(gdata);
 		}
 		
-		if (scriptName.startsWith("xtz")) {
+		if (importName.startsWith("xtz")) {
 			
 			Label tmpLabel3 = toolkit.createLabel(sectionClient, "Note elements");
 			tmpLabel3.setToolTipText("Note elements that encodes ponctual notes");
